package it.unifi.dsi.aouc.adapters;

import it.unifi.dsi.aouc.model.ObjectFactory;
import it.unifi.dsi.aouc.model.PatientCommand;
import it.unifi.dsi.aouc.model.PatientEvent;
import it.unifi.dsi.aouc.model.PatientQuery;
import it.unifi.dsi.aouc.model.PatientQueryResult;

import java.util.List;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;

@WebService( 
		name = "patient-adapter", 
		targetNamespace = "http://www.aou-careggi.toscana.it/eai"
)
@XmlSeeAlso({ObjectFactory.class})
public interface PatientAdapter {

	@WebMethod(action = "http://www.aou-careggi.toscana.it/eai/patient-adapter/notifyEvents")
	@WebResult(name = "patient-event" )
	@RequestWrapper(
			localName = "notifyEvents", 
			className = "it.unifi.dsi.aouc.model.NotifyEvents"
	)
	@ResponseWrapper(
			localName = "notifyEventsResponse", 
			className = "it.unifi.dsi.aouc.model.NotifyEventsResponse"
	)
	public List<PatientEvent> notifyEvents();

	
	
	@WebMethod(action = "http://www.aou-careggi.toscana.it/eai/patient-adapter/executeCommand")
	@WebResult(name = "result")
	@RequestWrapper(
			localName = "executeCommand", 
			className = "it.unifi.dsi.aouc.model.ExecuteCommand"
	)
	@ResponseWrapper(
			localName = "executeCommandResponse", 
			className = "it.unifi.dsi.aouc.model.ExecuteCommandResponse"
	)
	public boolean executeCommand( 
			@WebParam(name = "patient-command")
			PatientCommand patientCommand 
	);

	
	
	@WebMethod(action = "http://www.aou-careggi.toscana.it/eai/patient-adapter/executeQuery")
	@WebResult(name = "patient-query-result")
	@RequestWrapper(
			localName = "executeQuery", 
			className = "it.unifi.dsi.aouc.model.ExecuteQuery"
	)
	@ResponseWrapper(
			localName = "executeQueryResponse", 
			className = "it.unifi.dsi.aouc.model.ExecuteQueryResponse"
	)
	public PatientQueryResult executeQuery( 
			@WebParam(name = "patient-query")
			PatientQuery patientQuery 
	);

}
