package it.unifi.dsi.aouc.idm;

import it.unifi.dsi.aouc.model.ObjectFactory;
import it.unifi.dsi.aouc.model.Patient;
import it.unifi.dsi.aouc.model.PatientCommand;
import it.unifi.dsi.aouc.model.PatientEvent;
import it.unifi.dsi.aouc.model.PatientQuery;

import java.util.List;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;

 
@WebService(
		name = "patient-identity-manager",
		targetNamespace = "http://www.aou-careggi.toscana.it/eai"
)
@XmlSeeAlso({ObjectFactory.class})
public interface PatientIdentityManager {

	@WebMethod(action = "http://www.aou-careggi.toscana.it/eai/patient-identity-manager/receiveEvent")
    @WebResult(name = "result")
    @RequestWrapper(
    		localName = "receiveEvent",
    		className = "it.unifi.dsi.aouc.model.ReceiveEvent"
    )
    @ResponseWrapper(
    		localName = "receiveEventResponse", 
    		className = "it.unifi.dsi.aouc.model.ReceiveEventResponse"
    )
    public boolean receiveEvent(
        @WebParam(name = "patient-event")
        PatientEvent patientEvent
    );

	
	@WebMethod(action = "http://www.aou-careggi.toscana.it/eai/patient-identity-manager/generateCommands")
    @WebResult(name = "patient-command")
    @RequestWrapper(
    		localName = "generateCommands", 
    		className = "it.unifi.dsi.aouc.model.GenerateCommands"
    )
    @ResponseWrapper(
    		localName = "generateCommandsResponse", 
    		className = "it.unifi.dsi.aouc.model.GenerateCommandsResponse"
    )
    public List<PatientCommand> generateCommands(
        @WebParam(name = "patient")
        Patient patient
    );

	
	@WebMethod(action = "http://www.aou-careggi.toscana.it/eai/patient-identity-manager/refreshRelation")
    @WebResult(name = "result")
    @RequestWrapper(
    		localName = "refreshRelation", 
    		className = "it.unifi.dsi.aouc.model.RefreshRelation"
    )
    @ResponseWrapper(
    		localName = "refreshRelationResponse", 
    		className = "it.unifi.dsi.aouc.model.RefreshRelationResponse"
    )
    public boolean refreshRelation(
        @WebParam(name = "patient1")
        Patient patient1,
        @WebParam(name = "patient2")
        Patient patient2
    );

	
	@WebMethod(action = "http://www.aou-careggi.toscana.it/eai/patient-identity-manager/generateQueries")
    @WebResult(name = "patient-query")
    @RequestWrapper(
    		localName = "generateQueries", 
    		className = "it.unifi.dsi.aouc.model.GenerateQueries"
    )
    @ResponseWrapper(
    		localName = "generateQueriesResponse", 
    		className = "it.unifi.dsi.aouc.model.GenerateQueriesResponse"
    )
    public List<PatientQuery> generateQueries(
        @WebParam(name = "patient")
        Patient patient
    );
}
